<template>
  <div class="confirmacion">
    <Navbar />
    <div class="container-fluid mt-3 padding">
      <div class="padding">
        <div class="card">
          <div class="card-header d-flex justify-content-between">
            <h1 class="card-title">Confirmación</h1>
            <div>
              <button
                type="button"
                class="btn btn-secondary"
                :disabled="confirmacion"
                @click="getCodigo"
              >
                <i class="fas fa-paper-plane"></i>
                Enviar codigo
              </button>
            </div>
          </div>
          <div class="card-body">
            <div class="row justify-content-center">
              <div class="col-12 col-md-6">
                <form @submit.prevent="sendConfirmacion" autocomplete="off">
                  <div class="row justify-content-center text-danger" v-if="errorMessage">
                    {{errorMessage}}
                  </div>
                  <div class="form-group">
                    <label for="codigo">Codigo</label>
                    <input
                      type="text"
                      class="form-control"
                      :class="{'is-valid': !$v.codigo.$invalid, 'is-invalid': $v.codigo.$invalid || errors.codigo}"
                      placeholder="Codigo"
                      v-model="$v.codigo.$model"
                      maxlength=""
                    >
                    <div class="text-danger" v-if="!$v.codigo.validacionCodigo">
                      El formato del campo es inválido.
                    </div>
                    <div
                      class="text-danger"
                      v-for="(errorCodigo, index) in errors.codigo"
                      :key="index"
                    >
                      {{errorCodigo}}
                    </div>
                  </div>
                  <button
                    type="submit"
                    class="btn btn-primary"
                    :disabled="$v.$invalid || loading"
                  >
                    <i
                      class="fas"
                      :class="{'fa-share-square': !loading, 'fa-spinner fa-pulse': loading}"
                    />
                    Enviar
                  </button>
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <Footer />
  </div>
</template>

<script>
import Navbar from '@/components/Navbar.vue'
import Footer from '@/components/Footer.vue'
import { mapActions, mapState } from 'vuex'

const validacionCodigo = (value) => /^[C]{1}-[a-zA-Z0-9]{4}-[a-zA-Z0-9]{4}-[a-zA-Z0-9]{4}$/.test(value)

export default {
  data() {
    return {
      codigo: '',
      confirmacion: false,
      loading: false,
      errorMessage: '',
      errors: []
    }
  },
  components: {
    Navbar, Footer
  },
  methods: {
    ...mapActions('usuario', ['saveUsuario']),
    getConfig() {
      return {
        headers: {
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token.token}`,
          'apikey': this.usuario.apikey
        }
      }
    },
    getCodigo() {
      this.confirmacion = true
      this.axios.get('/auth/confirmation', this.getConfig())
        .then(res => {
          Toast.fire({
            icon: 'success',
            title: res.data.message
          })
          this.limpiarConfirmacion()
        })
        .catch(e => {
          Toast.fire({
            icon: 'error',
            title: e.response.data.message
          })
          this.limpiarConfirmacion()
        })
    },
    sendConfirmacion() {
      this.loading = true
      let body = {
        codigo: this.$v.codigo.$model
      }
      this.axios.post('/auth/confirmation', body, this.getConfig())
        .then(res => {
          this.loading = false
          this.limpiarConfirmacion()
          Toast.fire({
            icon: 'success',
            title: res.data.message
          })
          this.usuario.confirmado = true
          this.saveUsuario(this.usuario)
          this.$router.push({name: 'Tablero'})
        })
        .catch(e => {
          this.loading = false
          this.errorMessage = e.response.data.message
          this.errors = e.response.data.body?.errores ?? []
          this.limpiarErrorMessage()
        })
    },
    limpiarErrorMessage() {
      setTimeout(() => {
        this.errorMessage = ''
      }, 6000);
    },
    limpiarErrores(name) {
      delete this.errors[name]
    },
    limpiarConfirmacion() {
      setTimeout(() => {
        this.confirmacion = false
      }, 2000);
    }
  },
  computed: {
    ...mapState('usuario', ['usuario', 'token'])
  },
  validations: {
    codigo: {
      validacionCodigo
    }
  }
}
</script>
